<?xml version="1.0" standalone="yes" ?>
<?xml-stylesheet href="x2script.xsl" type="text/xsl" ?>
<script>
<name>plugin.Xai.XTC1.core</name>
<version>2</version>
<engineversion>25</engineversion>
<description>Main control for station supplying</description>
<arguments>
<argument index="1" name="selling" type="Value" desc="selling" />
<argument index="2" name="jumps.sell" type="Var/Number" desc="max jumps for selling" />
</arguments>
<sourcetext>
<line linenr="001" indent=""><comment><text>*&#160;</text><var>Created&#160;by&#160;Xai&#160;Corporation,&#160;764</var></comment></line>
<line linenr="002" indent=""><comment><text>*&#160;</text><var>Part&#160;of&#160;Xai&#160;Corporation&#160;Trade&#160;Command&#160;Software&#160;Mk1</var></comment></line>
<line linenr="003" indent=""><comment><text>*&#160;</text><var></var></comment></line>
<line linenr="004" indent=""><comment><text>*&#160;</text><var>Based&#160;on&#160;the&#160;work&#160;of&#160;MrSouth</var></comment></line>
<line linenr="005" indent=""><comment><text>*&#160;</text><var></var></comment></line>
<line linenr="006" indent=""><text>infinite&#160;loop&#160;detection&#160;enabled=</text><var>[TRUE]</var></line>
<line linenr="007" indent=""><comment><text>*&#160;</text><var>get&#160;wares&#160;array</var></comment></line>
<line linenr="008" indent=""><var>$product&#160;=&#160;</var><var>[HOMEBASE]&#160;-&gt;</var><text>&#160;get&#160;product&#160;ware</text></line>
<line linenr="009" indent=""><var>$home.resArray&#160;=&#160;</var><var>[HOMEBASE]&#160;-&gt;</var><text>&#160;get&#160;tradeable&#160;ware&#160;array&#160;from&#160;station</text></line>
<line linenr="010" indent=""></line>
<line linenr="011" indent=""><var>$home.resArray.size&#160;=&#160;</var><text>&#160;size&#160;of&#160;array&#160;</text><var>$home.resArray</var></line>
<line linenr="012" indent=""><var>while&#160;</var><var>$home.resArray.size</var></line>
<line linenr="013" indent="&#160;"><text>dec&#160;</text><var>$home.resArray.size&#160;=&#160;</var></line>
<line linenr="014" indent="&#160;"><var>$resource&#160;=&#160;</var><var>$home.resArray</var><text>[</text><var>$home.resArray.size</var><text>]</text></line>
<line linenr="015" indent="&#160;"></line>
<line linenr="016" indent=""><comment><text>*&#160;</text><var>&#160;remove&#160;product&#160;from&#160;array</var></comment></line>
<line linenr="017" indent="&#160;"><var>skip&#160;if&#160;not&#160;</var><var>$resource</var><text>&#160;</text><var>==</var><text>&#160;</text><var>$product</var></line>
<line linenr="018" indent="&#160;&#160;"><text>remove&#160;element&#160;from&#160;array&#160;</text><var>$home.resArray</var><text>&#160;at&#160;index&#160;</text><var>$home.resArray.size</var></line>
<line linenr="019" indent="&#160;"></line>
<line linenr="020" indent=""><comment><text>*&#160;</text><var>&#160;remove&#160;resources&#160;this&#160;cannot&#160;carry&#160;from&#160;array</var></comment></line>
<line linenr="021" indent="&#160;"><var>if&#160;not&#160;</var><var>[THIS]&#160;-&gt;</var><text>&#160;can&#160;transport&#160;ware&#160;</text><var>$resource</var></line>
<line linenr="022" indent="&#160;&#160;"><var>skip&#160;if&#160;</var><var>$resource</var><text>&#160;</text><var>==</var><text>&#160;</text><var>$product</var></line>
<line linenr="023" indent="&#160;&#160;&#160;"><text>remove&#160;element&#160;from&#160;array&#160;</text><var>$home.resArray</var><text>&#160;at&#160;index&#160;</text><var>$home.resArray.size</var></line>
<line linenr="024" indent="&#160;&#160;"><var>$home.resArray.size&#160;=&#160;</var><text>&#160;size&#160;of&#160;array&#160;</text><var>$home.resArray</var></line>
<line linenr="025" indent="&#160;&#160;"><var>$msg.res&#160;=&#160;</var><text>sprintf:&#160;pageid=</text><var>5501</var><text>&#160;textid=</text><var>1018</var><text>,&#160;</text><var>$resource</var><text>,&#160;</text><var>null</var><text>,&#160;</text><var>null</var><text>,&#160;</text><var>null</var><text>,&#160;</text><var>null</var></line>
<line linenr="026" indent="&#160;&#160;"><var>skip&#160;if&#160;</var><var>$msg</var></line>
<line linenr="027" indent="&#160;&#160;&#160;"><var>$msg&#160;=&#160;</var><var>''</var></line>
<line linenr="028" indent="&#160;&#160;"><var>$msg&#160;=&#160;</var><var>$msg</var><text>&#160;</text><var>+</var><text>&#160;</text><var>$msg.res</var></line>
<line linenr="029" indent="&#160;"><text>end</text></line>
<line linenr="030" indent=""><text>end</text></line>
<line linenr="031" indent=""></line>
<line linenr="032" indent=""><comment><text>*&#160;</text><var>send&#160;any&#160;error&#160;messages</var></comment></line>
<line linenr="033" indent=""><var>if&#160;</var><var>$msg</var></line>
<line linenr="034" interruptable="@" indent="&#160;"><var>$msg&#160;=&#160;</var><var>[THIS]&#160;-&gt;</var><text>&#160;call&#160;script&#160;</text><call>plugin.Xai.lib.AP.message</call><text>&#160;:&#160;</text><text>&#160;Message&#160;Number=</text><var>31</var><text>&#160;</text><text>&#160;Arg&#160;1=</text><var>null</var><text>&#160;</text><text>&#160;Arg&#160;2=</text><var>[HOMEBASE]</var><text>&#160;</text><text>&#160;Arg&#160;3=</text><var>$msg</var><text>&#160;</text><text>&#160;Arg&#160;4=</text><var>null</var><text>&#160;</text><text>&#160;Arg&#160;5=</text><var>null</var></line>
<line linenr="035" indent="&#160;"><text>write&#160;to&#160;player&#160;logbook&#160;</text><var>$msg</var></line>
<line linenr="036" indent="&#160;"><text>play&#160;sample:&#160;incoming&#160;transmission&#160;</text><var>[IncomingTransmission.Message]</var><text>,&#160;from&#160;object&#160;</text><var>[THIS]</var></line>
<line linenr="037" indent=""><text>end</text></line>
<line linenr="038" indent=""></line>
<line linenr="039" indent=""><comment><text>*&#160;</text><var>set&#160;selling&#160;jumps</var></comment></line>
<line linenr="040" indent=""><var>skip&#160;if&#160;not&#160;</var><var>$jumps.sell</var><text>&#160;</text><var>&lt;</var><text>&#160;</text><var>0</var></line>
<line linenr="041" indent="&#160;"><var>$jumps.sell&#160;=&#160;</var><var>[HOMEBASE]&#160;-&gt;</var><text>&#160;get&#160;max&#160;trade&#160;jumps</text></line>
<line linenr="042" indent=""></line>
<line linenr="043" indent=""><comment><text>*&#160;</text><var>start&#160;main&#160;loop</var></comment></line>
<line linenr="044" indent=""><var>while&#160;</var><var>[TRUE]</var></line>
<line linenr="045" interruptable="@" indent="&#160;"><var>=&#160;</var><text>wait&#160;randomly&#160;from&#160;</text><var>2000</var><text>&#160;to&#160;</text><var>5000</var><text>&#160;ms</text></line>
<line linenr="046" interruptable="@" indent="&#160;"><var>=&#160;</var><var>[THIS]&#160;-&gt;</var><text>&#160;call&#160;script&#160;</text><call>plugin.Xai.XTC1.action</call><text>&#160;:&#160;</text><text>&#160;Resources=</text><var>$home.resArray</var><text>&#160;</text><text>&#160;Sell&#160;product&#160;or&#160;not=</text><var>$selling</var><text>&#160;</text><text>&#160;max&#160;jumps&#160;for&#160;selling=</text><var>$jumps.sell</var></line>
<line linenr="047" indent="&#160;"></line>
<line linenr="048" interruptable="@" indent="&#160;"><var>=&#160;</var><var>[THIS]&#160;-&gt;</var><text>&#160;call&#160;script&#160;</text><call>plugin.Xai.lib.ship.diag</call><text>&#160;:&#160;</text></line>
<line linenr="049" indent=""><text>end</text></line>
<line linenr="050" indent=""></line>
<line linenr="051" indent=""><text>return&#160;</text><var>null</var></line>
</sourcetext>
<codearray>
<sval type="array" size="10"><sval type="string" val="plugin.Xai.XTC1.core" /><sval type="int" val="25" /><sval type="string" val="Main control for station supplying" /><sval type="int" val="2" /><sval type="int" val="0" /><sval type="array" size="8"><sval type="string" val="selling" /><sval type="string" val="jumps.sell" /><sval type="string" val="product" /><sval type="string" val="home.resArray" /><sval type="string" val="home.resArray.size" /><sval type="string" val="resource" /><sval type="string" val="msg.res" /><sval type="string" val="msg" /></sval><sval type="array" size="30"><sval type="array" size="3"><sval type="int" val="153" /><sval type="int" val="131075" /><sval type="int" val="10" /></sval><sval type="array" size="4"><sval type="int" val="638" /><sval type="int" val="131075" /><sval type="int" val="65540" /><sval type="int" val="2" /></sval><sval type="array" size="4"><sval type="int" val="1041" /><sval type="int" val="131075" /><sval type="int" val="65540" /><sval type="int" val="3" /></sval><sval type="array" size="4"><sval type="int" val="131" /><sval type="int" val="4" /><sval type="int" val="131074" /><sval type="int" val="3" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-1610608119" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="4" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="2"><sval type="int" val="143" /><sval type="int" val="4" /></sval><sval type="array" size="6"><sval type="int" val="129" /><sval type="int" val="5" /><sval type="int" val="131074" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="4" /></sval><sval type="array" size="13"><sval type="int" val="104" /><sval type="int" val="-1610610424" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="5" /><sval type="int" val="131074" /><sval type="int" val="2" /><sval type="int" val="15" /><sval type="int" val="0" /><sval type="int" val="3" /><sval type="int" val="-1" /><sval type="int" val="0" /><sval type="int" val="-2" /></sval><sval type="array" size="5"><sval type="int" val="136" /><sval type="int" val="131074" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="4" /></sval><sval type="array" size="6"><sval type="int" val="617" /><sval type="int" val="131075" /><sval type="int" val="65536" /><sval type="int" val="-536866556" /><sval type="int" val="131074" /><sval type="int" val="5" /></sval><sval type="array" size="13"><sval type="int" val="104" /><sval type="int" val="-536867833" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="5" /><sval type="int" val="131074" /><sval type="int" val="2" /><sval type="int" val="15" /><sval type="int" val="0" /><sval type="int" val="3" /><sval type="int" val="-1" /><sval type="int" val="0" /><sval type="int" val="-2" /></sval><sval type="array" size="5"><sval type="int" val="136" /><sval type="int" val="131074" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="4" /></sval><sval type="array" size="4"><sval type="int" val="131" /><sval type="int" val="4" /><sval type="int" val="131074" /><sval type="int" val="3" /></sval><sval type="array" size="16"><sval type="int" val="150" /><sval type="int" val="6" /><sval type="int" val="4" /><sval type="int" val="5501" /><sval type="int" val="4" /><sval type="int" val="1018" /><sval type="int" val="131074" /><sval type="int" val="5" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-536866809" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="7" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="7" /><sval type="int" val="1" /><sval type="int" val="5" /><sval type="string" val="" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="13"><sval type="int" val="104" /><sval type="int" val="7" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="7" /><sval type="int" val="131074" /><sval type="int" val="6" /><sval type="int" val="15" /><sval type="int" val="11" /><sval type="int" val="3" /><sval type="int" val="-1" /><sval type="int" val="11" /><sval type="int" val="-2" /></sval><sval type="array" size="2"><sval type="int" val="112" /><sval type="int" val="4" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-1610607101" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="7" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="18"><sval type="int" val="102" /><sval type="string" val="plugin.Xai.lib.AP.message" /><sval type="int" val="7" /><sval type="int" val="131075" /><sval type="int" val="65536" /><sval type="int" val="6" /><sval type="int" val="4" /><sval type="int" val="31" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="131075" /><sval type="int" val="65540" /><sval type="int" val="131074" /><sval type="int" val="7" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /><sval type="int" val="0" /></sval><sval type="array" size="3"><sval type="int" val="400" /><sval type="int" val="131074" /><sval type="int" val="7" /></sval><sval type="array" size="5"><sval type="int" val="201" /><sval type="int" val="131075" /><sval type="int" val="301" /><sval type="int" val="131075" /><sval type="int" val="65536" /></sval><sval type="array" size="13"><sval type="int" val="104" /><sval type="int" val="-1610606584" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="1" /><sval type="int" val="4" /><sval type="int" val="0" /><sval type="int" val="15" /><sval type="int" val="3" /><sval type="int" val="3" /><sval type="int" val="-1" /><sval type="int" val="3" /><sval type="int" val="-2" /></sval><sval type="array" size="4"><sval type="int" val="644" /><sval type="int" val="131075" /><sval type="int" val="65540" /><sval type="int" val="1" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-1610605303" /><sval type="int" val="1" /><sval type="int" val="131075" /><sval type="int" val="10" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="6"><sval type="int" val="107" /><sval type="int" val="-2147483647" /><sval type="int" val="4" /><sval type="int" val="2000" /><sval type="int" val="4" /><sval type="int" val="5000" /></sval><sval type="array" size="12"><sval type="int" val="102" /><sval type="string" val="plugin.Xai.XTC1.action" /><sval type="int" val="-2147483647" /><sval type="int" val="131075" /><sval type="int" val="65536" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="0" /><sval type="int" val="131074" /><sval type="int" val="1" /></sval><sval type="array" size="6"><sval type="int" val="102" /><sval type="string" val="plugin.Xai.lib.ship.diag" /><sval type="int" val="-2147483647" /><sval type="int" val="131075" /><sval type="int" val="65536" /><sval type="int" val="0" /></sval><sval type="array" size="2"><sval type="int" val="112" /><sval type="int" val="24" /></sval><sval type="array" size="3"><sval type="int" val="103" /><sval type="int" val="0" /><sval type="int" val="0" /></sval></sval><sval type="array" size="2"><sval type="array" size="2"><sval type="int" val="9" /><sval type="string" val="selling" /></sval><sval type="array" size="2"><sval type="int" val="10" /><sval type="string" val="max jumps for selling" /></sval></sval><sval type="array" size="23"><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="Created by Xai Corporation, 764" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="Part of Xai Corporation Trade Command Software Mk1" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="Based on the work of MrSouth" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="" /></sval><sval type="array" size="3"><sval type="int" val="1" /><sval type="int" val="1" /><sval type="string" val="get wares array" /></sval><sval type="array" size="2"><sval type="int" val="3" /><sval type="int" val="2" /></sval><sval type="array" size="2"><sval type="int" val="7" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="7" /><sval type="int" val="1" /><sval type="string" val=" remove product from array" /></sval><sval type="array" size="2"><sval type="int" val="9" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="9" /><sval type="int" val="1" /><sval type="string" val=" remove resources this cannot carry from array" /></sval><sval type="array" size="2"><sval type="int" val="17" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="18" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="18" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="18" /><sval type="int" val="1" /><sval type="string" val="send any error messages" /></sval><sval type="array" size="2"><sval type="int" val="22" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="22" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="22" /><sval type="int" val="1" /><sval type="string" val="set selling jumps" /></sval><sval type="array" size="2"><sval type="int" val="24" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="24" /><sval type="int" val="1" /><sval type="string" val="start main loop" /></sval><sval type="array" size="2"><sval type="int" val="27" /><sval type="int" val="2" /></sval><sval type="array" size="2"><sval type="int" val="29" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="29" /><sval type="int" val="2" /></sval></sval><sval type="int" val="420" /></sval>
</codearray>
</script>
